/** Update script example whenever modifications made to edit script mask */
$('#edit_script_mask').focusout(function(){
    updateExampleScript(document.getElementById("edit_script_mask").value, document.getElementById("editscriptmodalexample"), document.getElementById("editscriptmodalAlerts"));
});

function enableDisableScriptFieldButtons(modalId,select,buttonIdFirstValue, buttonIdSecondValue)
{
    var selectedValue = document.getElementById(select).value;
    var isMulti       = selectedValue.substring(selectedValue.indexOf(":")+1);
    if(isMulti==='true')
    {
        document.getElementById(buttonIdFirstValue).disabled=false;
        document.getElementById(buttonIdSecondValue).disabled=false;
    }
    else
    {
        document.getElementById(buttonIdFirstValue).disabled=true;
        document.getElementById(buttonIdSecondValue).disabled=true;
    }
}

function addFunctionToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var functionPrototype = selectedValue;

    if(mask.value.length==0)
    {
        mask.value = mask.value += functionPrototype;
    }
    else
    {
        mask.value = mask.value +=" + " + functionPrototype;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

/** Add folder separator to the mask
*/
function addSimpleToScript(modalId,select, maskId)
{
    var mask          = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar;
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addFirstValueToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[0]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[0]";;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addSecondValueToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[1]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[1]";;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}


/** Update Example when editing or adding a script
*/
function updateExampleScript(maskValue, exampleField, alertsField)
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', '/preferences.example_script', true);
  xhr.send(maskValue);
        xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok'))
            {
               exampleField.innerHTML=xhr.responseText.substring(3);
               removeAllAlerts(alertsField);
            }
            else
            {
               var errorMsgWithoutErrorCode=xhr.responseText.substring(6);
               var errorMsg=errorMsgWithoutErrorCode.substring(0, errorMsgWithoutErrorCode.indexOf(':'));
               var exampleMsg=errorMsgWithoutErrorCode.substring(errorMsgWithoutErrorCode.indexOf(':') + 1);
               exampleField.innerHTML=exampleMsg;
               addAlertToModal(alertsField, errorMsg);
            }
        }
     };
}

/** Update script example whenever modifications made to edit script mask */
$('#overallScript').focusout(function(){
    updateExampleScript(document.getElementById("overallScript").value, document.getElementById("editscriptmodalexample"), document.getElementById("editscriptmodalAlerts"));
});

/** Add the selected script top the overall script */
function addScriptToOverallScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    mask.value = mask.value += "\n" + selectedValue;

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function validateOverallScript(modalId,select, maskId)
{
    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

/** Calculate examples on page load */
window.onload=updateExampleScript(document.getElementById("overallScript").value, document.getElementById("editscriptmodalexample"), document.getElementById("editscriptmodalAlerts"));